B=xlsread('B.xlsx');
obs=xlsread('obs.xlsx');
n=1000; % iteration number
m=size(B,1);
m_obs=0.1*m*m;
X=zeros(3,m,m);
s=1.3;
lambda=0.005;
t=zeros(n,1);
for i=1:2
    for j=1:m_obs
        t(i)=t(i)+0.5*(X(mod(i,3)+1,obs(j,1),obs(j,2))-B(obs(j,1),obs(j,2)))^2;
    end
end
for i=2:n-1
    Y=(2*i-3)/(i)*X(mod(i,3)+1,:,:)-(i-3)/(i)*X(mod(i-1,3)+1,:,:);
    Y=reshape(Y,m,m);
    nabla_fy=zeros(m,m);
    for j=1:m_obs
        nabla_fy(obs(j,1),obs(j,2))=Y(obs(j,1),obs(j,2))-B(obs(j,1),obs(j,2));
    end  % compute \nabla f(Y)
    grad_f=Y-s*nabla_fy; % Y-\frac{ns}{2n+4}\nabla f(Z)
    [U,Sigma,V]=svd(grad_f);
    Sigma=max(Sigma-s*lambda*eye(m),zeros(m));
    X(mod(i+1,3)+1,:,:)=U*Sigma*V';
    for j=1:m_obs
        t(i+1)=t(i+1)+0.5*(X(mod(i+1,3)+1,obs(j,1),obs(j,2))-B(obs(j,1),obs(j,2)))^2;
    end
    t(i+1)=t(i+1)+lambda*sum(diag(Sigma));
end
semilogy((1:4:n/2),t(1:4:n/2)-0.02810523108535746203417993,'xr','MarkerSize',8);
%xlabel('n');
%ylabel('$|F-F^*|$','Interpreter','LaTex');
hold on;
%plot(t);