B=xlsread('B.xlsx');
obs=xlsread('obs.xlsx');
n=1000; % iteration number
m=size(B,1);
m_obs=0.1*m*m;
X=zeros(4,m,m);
s=10;
lambda=0.005;
beta=0.1;
t=zeros(n,1);
for i=1:3
    for j=1:m_obs
        t(i)=t(i)+0.5*(X(mod(i,4)+1,obs(j,1),obs(j,2))-B(obs(j,1),obs(j,2)))^2;
    end
end
for i=3:n-1
    Y=(10*i*i+9*i+6)/(4*i*i+8*i)*X(mod(i,4)+1,:,:)-(4*i*i+3)/(2*i*i+4*i)*X(mod(i-1,4)+1,:,:)+(2*i-1)/(4*i+8)*X(mod(i-2,4)+1,:,:);
    Y=reshape(Y,m,m);
    Z=(2*i-3)/(i)*X(mod(i,4)+1,:,:)-(i-3)/(i)*X(mod(i-1,4)+1,:,:);
    Z=reshape(Z,m,m);
    nabla_fz=zeros(m,m);
    for j=1:m_obs
        nabla_fz(obs(j,1),obs(j,2))=Z(obs(j,1),obs(j,2))-B(obs(j,1),obs(j,2));
    end  % compute \nabla f(Y)
    while true
        grad_f=Y-(i*s)/(2*i+4)*nabla_fz; % Y-\frac{ns}{2n+4}\nabla f(Z)
        [U,Sigma,V]=svd(grad_f);
        Sigma=max(Sigma-(i*s*lambda)/(2*i+4)*eye(m),zeros(m));
        x_t=U*Sigma*V';
        f_x_t=F2obs(x_t,B,obs,m_obs);
        f_Y=F2obs(Y,B,obs,m_obs);
        if (f_x_t<f_Y+sum(sum((x_t-Y).*nabla_fz))+(i+2)/(i*s)*norm(x_t-Y,'fro'))
            break;
        end
        s=s*beta;
    end
    X(mod(i+1,4)+1,:,:)=x_t;
    for j=1:m_obs
        t(i+1)=t(i+1)+0.5*(X(mod(i+1,4)+1,obs(j,1),obs(j,2))-B(obs(j,1),obs(j,2)))^2;
    end
    t(i+1)=t(i+1)+lambda*sum(diag(Sigma));
end
semilogy((1:10:n),t(1:10:n)-0.02810523108535746203417993,'+b');
%plot(t);